using System;
using System.Data;
using System.Text;
using System.Data.SqlClient;
using System.Data.OracleClient;
using System.Data.OleDb;
using System.Data.SqlTypes;
using System.Runtime.InteropServices;
using System.Globalization;
using System.Resources; 
using System.Threading;
using System.Reflection; 
using System.Collections; 
using System.Runtime.CompilerServices;
using UCMLCommon;



namespace DBLayer
{
    /// <summary>
    /// Summary description for ofOffline.
    /// </summary>
    
    
    public class ofOffline:UCMLCommon.UCML_MSSQL_DAO
    {
        public ofOffline()
        {
            TableName="ofOffline";
            IsUseCache = false;
            FieldInfoArray = InitFieldInfo();
            DBType = UCMLCommon.DBType.MSSQL;
            Provider = UCMLCommon.DBProvider.MSSQLNA;
            DBConnIndex = 0;
            strConn=UCMLCommon.UCMLInitEnv.GetDBConns(DBConnIndex);
            UCMLMapTableArray = new UCMLMapTable[1];
            UCMLMapTable map;
            map = new UCMLMapTable();
            map.TableName ="ofOffline";
            map.BaseTableFlag=true;
            UCMLMapTableArray[0] = map;
            fIDENTITYKey = false;
            fHaveUCMLKey = false;
            fRecordHistroy = false;
            fViewTable = false;
            UCMLCommon.UCMLKey key;
            key = new UCMLCommon.UCMLKey();
            key.KeyName ="username";
            key.KeyType =2;
            key.KeyTypeCS =typeof(String);
            KeyCollection.AddKey(key.KeyName,key);
            key = new UCMLCommon.UCMLKey();
            key.KeyName ="messageID";
            key.KeyType =10;
            key.KeyTypeCS =typeof(Int32);
            KeyCollection.AddKey(key.KeyName,key);
            
        }
            
        public ofOffline(Object conn,Object transaction)
        {
            IsUseCache = false;
            TableName="ofOffline";
            DBType = UCMLCommon.DBType.MSSQL;
            Provider = UCMLCommon.DBProvider.MSSQLNA;
            DBConnIndex = 0;
            strConn=UCMLCommon.UCMLInitEnv.GetDBConns(DBConnIndex);
            UCMLMapTableArray = new UCMLMapTable[1];
            UCMLMapTable map;
            map = new UCMLMapTable();
            map.TableName ="ofOffline";
            map.BaseTableFlag=true;
            UCMLMapTableArray[0] = map;
            fIDENTITYKey = false;
            fHaveUCMLKey = false;
            fRecordHistroy = false;
            fViewTable = false;
            UCMLCommon.UCMLKey key;
            key = new UCMLCommon.UCMLKey();
            key.KeyName ="username";
            key.KeyType =2;
            key.KeyTypeCS =typeof(String);
            KeyCollection.AddKey(key.KeyName,key);
            key = new UCMLCommon.UCMLKey();
            key.KeyName ="messageID";
            key.KeyType =10;
            key.KeyTypeCS =typeof(Int32);
            KeyCollection.AddKey(key.KeyName,key);
            
            this.Connection = conn;
            this.Transaction = transaction;
        }
        /// <summary>
        /// ݹؼ,װһ¼objInfo,ؼҪȴobjInfo.ofOfflineOID
        /// </summary>
        /// <param name="objInfo">ڴݺʹؼ</param>
        /// <returns>ɹ,1</returns>
        public Int32 Load(ofOfflineInfo objInfo )
        {
            Int32 result = 0;
            StringBuilder commandText = new StringBuilder("SELECT username, messageID, creationDate, messageSize, stanza   ");
            commandText.Append("FROM ofOffline ");
            commandText.Append("WHERE (username = @username and messageID = @messageID)");

                SqlConnection Conn = null;
            try
            {
                if (Connection==null)
                {
                    Conn = new SqlConnection(strConn);
                    Conn.Open();
                }
                else
                    Conn = (SqlConnection)Connection;
                SqlCommand DSCmd = new SqlCommand(commandText.ToString(),Conn);
                if (Transaction!=null)
                    DSCmd.Transaction = (SqlTransaction)Transaction;

                DSCmd.Parameters.AddWithValue("@username",objInfo.username);
                DSCmd.Parameters.AddWithValue("@messageID",objInfo.messageID);
             string SQL="";
             if (ReadCacheDataToInfo(objInfo, DSCmd,ref SQL)==true) return 0;
                            SqlDataReader dataReader = DSCmd.ExecuteReader();
                if (dataReader.Read())
                {
                    if (dataReader["username"] != DBNull.Value)
                      objInfo.username = dataReader.GetString(dataReader.GetOrdinal("username"));
                    if (dataReader["messageID"] != DBNull.Value)
                      objInfo.messageID = Convert.ToInt32(dataReader["messageID"]);
                    if (dataReader["creationDate"] != DBNull.Value)
                      objInfo.creationDate = dataReader.GetString(dataReader.GetOrdinal("creationDate"));
                    if (dataReader["messageSize"] != DBNull.Value)
                      objInfo.messageSize = Convert.ToInt32(dataReader["messageSize"]);
                    if (dataReader["stanza"] != DBNull.Value)
                      objInfo.stanza = dataReader.GetString(dataReader.GetOrdinal("stanza"));
                    result = 1;
                }
                else
                    result = 0;
                WrtieInfoDataToCache(objInfo,SQL);
                dataReader.Close();
            }
            catch (Exception e)
            {
                throw new Exception(e.Message);
            }
            finally
            {
                if (Conn!=null&&Connection==null) Conn.Close();
            }
            return result;
        }

        /// <summary>
        /// һ¼,objInfo
        /// </summary>
        /// <param name="objInfo">ڴ</param>
        /// <returns>0ʧ</returns>
        public Int32 Insert(ofOfflineInfo objInfo )
        {
            Int32 result = 0;
            StringBuilder commandText = new StringBuilder("INSERT INTO ofOffline " );
            commandText.Append("( username, messageID, creationDate, messageSize, stanza   ) ");
            commandText.Append(" VALUES(@username, @messageID, @creationDate, @messageSize, @stanza   )");
            if (this.fIDENTITYKey==true && DBType == UCMLCommon.DBType.MSSQL)
            {
            	commandText.Append("\n select SCOPE_IDENTITY() AS 'Identity' \n");
            }
            
                SqlConnection Conn = null;
            try
            {
                if (Connection==null)
                {
                    Conn = new SqlConnection(strConn);
                    Conn.Open();
                }
                else
                    Conn = (SqlConnection)Connection;
                SqlCommand DSCmd = new SqlCommand(commandText.ToString(),Conn);
                if (Transaction!=null)
                    DSCmd.Transaction = (SqlTransaction)Transaction;
            
                DSCmd.Parameters.AddWithValue("@username",objInfo.username);
                DSCmd.Parameters.AddWithValue("@messageID",objInfo.messageID);
                DSCmd.Parameters.AddWithValue("@creationDate",objInfo.creationDate);
                DSCmd.Parameters.AddWithValue("@messageSize",objInfo.messageSize);
                DSCmd.Parameters.AddWithValue("@stanza",objInfo.stanza);
                result = DSCmd.ExecuteNonQuery();
                InsertToCache(DSCmd);
            }
            catch (Exception e)
            {
            	throw new Exception(e.Message);
            }
            finally
            {
                if (Conn!=null&&Connection==null) Conn.Close();
            }
            return result;
        }

        /// <summary>
        /// ݹؼ,ɾһ¼,ؼҪȴobjInfo.ofOfflineOID
        /// </summary>
        /// <param name="objInfo">ڴؼ</param>
        /// <returns>ʧܷ0</returns>
        public Int32 Delete(ofOfflineInfo objInfo )
        {
            Int32 result = 0;
            StringBuilder commandText = new StringBuilder("DELETE FROM ofOffline ");
            commandText.Append("WHERE (username = @username and messageID = @messageID)");
            
                SqlConnection Conn = null;
            try
            {
                if (Connection==null)
                {
                    Conn = new SqlConnection(strConn);
                    Conn.Open();
                }
                else
                    Conn = (SqlConnection)Connection;
                SqlCommand DSCmd = new SqlCommand(commandText.ToString(),Conn);
                if (Transaction!=null)
                    DSCmd.Transaction = (SqlTransaction)Transaction;
                DSCmd.Parameters.AddWithValue("@username",objInfo.username);
                DSCmd.Parameters.AddWithValue("@messageID",objInfo.messageID);
                result = DSCmd.ExecuteNonQuery();
                DeleteFromCache(DSCmd);
            }
            catch (Exception e)
            {
            	throw new Exception(e.Message);
            }
            finally
            {
                if (Conn!=null&&Connection==null) Conn.Close();
            }
            return result;
        }
        public Int32 DeleteAll()
        {
            Int32 result = 0;
            StringBuilder commandText = new StringBuilder("DELETE FROM ofOffline ");
            
                SqlConnection Conn = null;
            try
            {
                if (Connection==null)
                {
                    Conn = new SqlConnection(strConn);
                    Conn.Open();
                }
                else
                    Conn = (SqlConnection)Connection;
                SqlCommand DSCmd = new SqlCommand(commandText.ToString(),Conn);
                if (Transaction!=null)
                    DSCmd.Transaction = (SqlTransaction)Transaction;
                result = DSCmd.ExecuteNonQuery();
            }
            catch (Exception e)
            {
            	throw new Exception(e.Message);
            }
            finally
            {
                if (Conn!=null&&Connection==null) Conn.Close();
            }
            return result;
        }

        /// <summary>
        /// ݹؼ,޸һ¼,ؼҪȴobjInfo.ofOfflineOID
        /// </summary>
        /// <param name="objInfo">ڴݺ͹ؼ</param>
        /// <returns>ʧܷ0</returns>
        public Int32 Update(ofOfflineInfo objInfo )
        {
            Int32 result = 0;
            StringBuilder commandText = new StringBuilder("UPDATE ofOffline ");
            commandText.Append("SET   creationDate = @creationDate, messageSize = @messageSize, stanza = @stanza   ");
            commandText.Append("WHERE (username = @username and messageID = @messageID)");
            
                SqlConnection Conn = null;
            try
            {
                if (Connection==null)
                {
                    Conn = new SqlConnection(strConn);
                    Conn.Open();
                }
                else
                    Conn = (SqlConnection)Connection;
                SqlCommand DSCmd = new SqlCommand(commandText.ToString(),Conn);
                if (Transaction!=null)
                    DSCmd.Transaction = (SqlTransaction)Transaction;
            
                DSCmd.Parameters.AddWithValue("@creationDate",objInfo.creationDate);
                DSCmd.Parameters.AddWithValue("@messageSize",objInfo.messageSize);
                DSCmd.Parameters.AddWithValue("@stanza",objInfo.stanza);
                DSCmd.Parameters.AddWithValue("@username",objInfo.username);
                DSCmd.Parameters.AddWithValue("@messageID",objInfo.messageID);
                result = DSCmd.ExecuteNonQuery();
                UpdateToCache(DSCmd);
            }
            catch (Exception e)
            {
            	throw new Exception(e.Message);
            }
            finally
            {
                if (Conn!=null&&Connection==null) Conn.Close();
            }
            return result;
        }
        
        /// <summary>
        /// ȡᶨ¼ĳֶεֵ
        /// </summary>
        /// <param name="FieldName">ֶ</param>
        /// <param name="KeyOID">¼ļֵ</param>
        /// <returns>صֵֶ</returns>
        override public Object GetFieldValue(string FieldName, Object KeyOID)
        {
            try
            {
                ofOfflineInfo objInfo = new ofOfflineInfo();
                objInfo.username = Convert.ToString(KeyOID);
                this.Load(objInfo);
                if ( FieldName == "username" )
                {
                    return objInfo.username;
                }
                if ( FieldName == "messageID" )
                {
                    return objInfo.messageID;
                }
                if ( FieldName == "creationDate" )
                {
                    return objInfo.creationDate;
                }
                if ( FieldName == "messageSize" )
                {
                    return objInfo.messageSize;
                }
                if ( FieldName == "stanza" )
                {
                    return objInfo.stanza;
                }
                return null;
            }
            catch (Exception e)
            {
            	throw new Exception(e.Message);
            }
        }
        /// <summary>
        /// ֶεֵ
        /// </summary>
        /// <param name="FieldName">ֶ</param>
        /// <param name="KeyOID">¼ļֵ</param>
        /// <param name="data">ֶθֵ</param>
        override public void  SetFieldValue(string FieldName, Object KeyOID, Object data)
        {
            Int32 result = 0;
            StringBuilder commandText = new StringBuilder("UPDATE ofOffline ");
                switch(FieldName)
                {
                case "username" :
                    commandText.Append("SET username=@username ");
                    break;
                case "messageID" :
                    commandText.Append("SET messageID=@messageID ");
                    break;
                case "creationDate" :
                    commandText.Append("SET creationDate=@creationDate ");
                    break;
                case "messageSize" :
                    commandText.Append("SET messageSize=@messageSize ");
                    break;
                case "stanza" :
                    commandText.Append("SET stanza=@stanza ");
                    break;
                }
            commandText.Append("WHERE (username = @username and messageID = @messageID)");
            
                SqlConnection Conn = null;
            try
            {
                if (Connection==null)
                {
                    Conn = new SqlConnection(strConn);
                    Conn.Open();
                }
                else
                    Conn = (SqlConnection)Connection;
                SqlCommand DSCmd = new SqlCommand(commandText.ToString(),Conn);
                if (Transaction!=null)
                    DSCmd.Transaction = (SqlTransaction)Transaction;
            
                switch(FieldName)
                {
                case "username" :
                DSCmd.Parameters.AddWithValue("@username",data);
                    break;
                case "messageID" :
                DSCmd.Parameters.AddWithValue("@messageID",data);
                    break;
                case "creationDate" :
                DSCmd.Parameters.AddWithValue("@creationDate",data);
                    break;
                case "messageSize" :
                DSCmd.Parameters.AddWithValue("@messageSize",data);
                    break;
                case "stanza" :
                DSCmd.Parameters.AddWithValue("@stanza",data);
                    break;
                }
                DSCmd.Parameters.AddWithValue("@username",KeyOID);
                DSCmd.Parameters.AddWithValue("@messageID",KeyOID);
                result = DSCmd.ExecuteNonQuery();
            }
            catch (Exception e)
            {
            	throw new Exception(e.Message);
            }
            finally
            {
                if (Conn!=null&&Connection==null) Conn.Close();
            }
        }
        /// <summary>
        /// </summary>
        /// <param name="strPrmusername"></param>
        /// <returns></returns>
        public ArrayList GetXmppOffMsg(String strPrmusername)
        {
            StringBuilder commandText = new StringBuilder("SELECT ofOffline.messageID,ofOffline.creationDate,ofOffline.stanza FROM ofOffline WHERE    (ofOffline.stanza LIKE '%type=\"chat\"%')    AND (ofOffline.username = @username)");
            ofOfflineInfo objInfo;
            ArrayList ofOfflineList = new ArrayList();
                SqlConnection Conn = null;
            try
            {
                if (Connection==null)
                {
                    Conn = new SqlConnection(strConn);
                    Conn.Open();
                }
                else
                    Conn = (SqlConnection)Connection;
                SqlCommand DSCmd = new SqlCommand(commandText.ToString(),Conn);
                if (Transaction!=null)
                    DSCmd.Transaction = (SqlTransaction)Transaction;

                DSCmd.Parameters.AddWithValue("@username",strPrmusername);
                                SqlDataReader dataReader = DSCmd.ExecuteReader();
                while (dataReader.Read())
                {
                    objInfo = new ofOfflineInfo();

                    if (dataReader["messageID"] != DBNull.Value)
                      objInfo.messageID = Convert.ToInt32(dataReader["messageID"]);
                    if (dataReader["creationDate"] != DBNull.Value)
                      objInfo.creationDate = dataReader.GetString(dataReader.GetOrdinal("creationDate"));
                    if (dataReader["stanza"] != DBNull.Value)
                      objInfo.stanza = dataReader.GetString(dataReader.GetOrdinal("stanza"));
                    ofOfflineList.Add(objInfo);
                }
                dataReader.Close();
            }
            catch (Exception e)
            {
                throw new Exception(e.Message);
            }
            finally
            {
                if (Conn!=null&&Connection==null) Conn.Close();
            }
            return ofOfflineList;
        }

        /// <summary>
        /// װ
        /// </summary>
        /// <returns>DataSet͵</returns>
        public DataSet LoadAll()
        {
            StringBuilder commandText = new StringBuilder("SELECT * FROM ofOffline");
            DataSet ds = new DataSet();
                SqlConnection Conn = null;
            try
            {
                if (Connection==null)
                {
                    Conn = new SqlConnection(strConn);
                    Conn.Open();
                }
                else
                    Conn = (SqlConnection)Connection;
                SqlCommand DSCmd = new SqlCommand(commandText.ToString(),Conn);
                if (Transaction!=null)
                    DSCmd.Transaction = (SqlTransaction)Transaction;

                                SqlDataAdapter DBAdopter = new System.Data.SqlClient.SqlDataAdapter(DSCmd);
                DBAdopter.Fill(ds,"ofOffline");
                DBAdopter.Fill(ds,"ofOfflineTemp");
                ds.Tables["ofOfflineTemp"].Rows.Clear();
            }
            catch (Exception e)
            {
                throw new Exception(e.Message);
            }
            finally
            {
                if (Conn!=null&&Connection==null) Conn.Close();
            }
            return ds;
        }
        /// <summary>
        /// װ
        /// </summary>
        /// <returns>DataTable͵</returns>
        public ofOfflineTable LoadAllTable()
        {
            StringBuilder commandText = new StringBuilder("SELECT * FROM ofOffline "+SQLLastFix);
            ofOfflineTable ds = new ofOfflineTable();
                SqlConnection Conn = null;
            try
            {
                if (Connection==null)
                {
                    Conn = new SqlConnection(strConn);
                    Conn.Open();
                }
                else
                    Conn = (SqlConnection)Connection;
                SqlCommand DSCmd = new SqlCommand(commandText.ToString(),Conn);
                if (Transaction!=null)
                    DSCmd.Transaction = (SqlTransaction)Transaction;

                                SqlDataAdapter DBAdopter = new System.Data.SqlClient.SqlDataAdapter(DSCmd);
                DBAdopter.Fill(ds);
            }
            catch (Exception e)
            {
                throw new Exception(e.Message);
            }
            finally
            {
                if (Conn!=null&&Connection==null) Conn.Close();
            }
            return ds;
        }

        public ofOfflineTable LoadTable(Object OID)
        {
            StringBuilder commandText = new StringBuilder("SELECT * FROM ofOffline ");
            commandText.Append("WHERE ofOfflineOID = @ofOfflineOID");
            ofOfflineTable ds = new ofOfflineTable();
                SqlConnection Conn = null;
            try
            {
                if (Connection==null)
                {
                    Conn = new SqlConnection(strConn);
                    Conn.Open();
                }
                else
                    Conn = (SqlConnection)Connection;
                SqlCommand DSCmd = new SqlCommand(commandText.ToString(),Conn);
                if (Transaction!=null)
                    DSCmd.Transaction = (SqlTransaction)Transaction;

                                SqlDataAdapter DBAdopter = new System.Data.SqlClient.SqlDataAdapter(DSCmd);
                DSCmd.Parameters.AddWithValue("@ofOfflineOID",OID);
                DBAdopter.Fill(ds);
            }
            catch (Exception e)
            {
                throw new Exception(e.Message);
            }
            finally
            {
                if (Conn!=null&&Connection==null) Conn.Close();
            }
            return ds;
        }
        
        private String GetResString(String resKey)
        {
        	  ResourceManager res = new ResourceManager("DBLayer",
        	  Assembly.GetExecutingAssembly());
        	  String strReturnVal = res.GetString(resKey);
        	  return strReturnVal;
        }
        
        static Boolean fInit = false;
        static UCMLCommon.FieldInfo[] localFieldInfoArray = null;
        private UCMLCommon.FieldInfo[] InitFieldInfo()
        {
            if (fInit==false)
            {
                FieldInfoArray = LoadFieldInfoFromXML();
                if (FieldInfoArray ==null)
                {
                FieldInfoArray = new UCMLCommon.FieldInfo[6];
                FieldInfoArray[0] = new UCMLCommon.FieldInfo();
                FieldInfoArray[0].FieldName = "ofOfflineOID"; FieldInfoArray[0].FieldChinese = ""; FieldInfoArray[0].FieldType = 46; FieldInfoArray[0].FieldLength = 0; FieldInfoArray[0].DecLength = 0; FieldInfoArray[0].CodeTable = "";FieldInfoArray[0].fUseCodeTable = false; FieldInfoArray[0].fDisplay = false; FieldInfoArray[0].DefaultValue = "";FieldInfoArray[0].FieldKind = 0; FieldInfoArray[0].IsMultiValueField = false; FieldInfoArray[0].MultiValueTable = ""; FieldInfoArray[0].fCanModify = false; FieldInfoArray[0].ForeignKeyField = "";FieldInfoArray[0].LookupKeyField = "";FieldInfoArray[0].LookupDataSet = "";FieldInfoArray[0].LookupResultField = ""; FieldInfoArray[0].RoleTable = "";FieldInfoArray[0].fAllowPick = false; FieldInfoArray[0].fForeignKey = false; 
                FieldInfoArray[1] = new UCMLCommon.FieldInfo();
                FieldInfoArray[1].FieldName = "username"; FieldInfoArray[1].FieldChinese = "ID"; FieldInfoArray[1].FieldType = 2; FieldInfoArray[1].FieldLength = 64; FieldInfoArray[1].DecLength = 0; FieldInfoArray[1].CodeTable = "";FieldInfoArray[1].fUseCodeTable = false; FieldInfoArray[1].fDisplay = true; FieldInfoArray[1].DefaultValue = "";FieldInfoArray[1].FieldKind = 0; FieldInfoArray[1].IsMultiValueField = false; FieldInfoArray[1].MultiValueTable = ""; FieldInfoArray[1].fCanModify = true; FieldInfoArray[1].ForeignKeyField = "";FieldInfoArray[1].LookupKeyField = "";FieldInfoArray[1].LookupDataSet = "";FieldInfoArray[1].LookupResultField = ""; FieldInfoArray[1].RoleTable = "";FieldInfoArray[1].fAllowPick = false; FieldInfoArray[1].fForeignKey = false; 
                FieldInfoArray[2] = new UCMLCommon.FieldInfo();
                FieldInfoArray[2].FieldName = "messageID"; FieldInfoArray[2].FieldChinese = "ϢID"; FieldInfoArray[2].FieldType = 10; FieldInfoArray[2].FieldLength = 0; FieldInfoArray[2].DecLength = 0; FieldInfoArray[2].CodeTable = "";FieldInfoArray[2].fUseCodeTable = false; FieldInfoArray[2].fDisplay = true; FieldInfoArray[2].DefaultValue = "";FieldInfoArray[2].FieldKind = 0; FieldInfoArray[2].IsMultiValueField = false; FieldInfoArray[2].MultiValueTable = ""; FieldInfoArray[2].fCanModify = true; FieldInfoArray[2].ForeignKeyField = "";FieldInfoArray[2].LookupKeyField = "";FieldInfoArray[2].LookupDataSet = "";FieldInfoArray[2].LookupResultField = ""; FieldInfoArray[2].RoleTable = "";FieldInfoArray[2].fAllowPick = false; FieldInfoArray[2].fForeignKey = false; 
                FieldInfoArray[3] = new UCMLCommon.FieldInfo();
                FieldInfoArray[3].FieldName = "creationDate"; FieldInfoArray[3].FieldChinese = "ʱ"; FieldInfoArray[3].FieldType = 2; FieldInfoArray[3].FieldLength = 15; FieldInfoArray[3].DecLength = 0; FieldInfoArray[3].CodeTable = "";FieldInfoArray[3].fUseCodeTable = false; FieldInfoArray[3].fDisplay = true; FieldInfoArray[3].DefaultValue = "";FieldInfoArray[3].FieldKind = 0; FieldInfoArray[3].IsMultiValueField = false; FieldInfoArray[3].MultiValueTable = ""; FieldInfoArray[3].fCanModify = true; FieldInfoArray[3].ForeignKeyField = "";FieldInfoArray[3].LookupKeyField = "";FieldInfoArray[3].LookupDataSet = "";FieldInfoArray[3].LookupResultField = ""; FieldInfoArray[3].RoleTable = "";FieldInfoArray[3].fAllowPick = false; FieldInfoArray[3].fForeignKey = false; 
                FieldInfoArray[4] = new UCMLCommon.FieldInfo();
                FieldInfoArray[4].FieldName = "messageSize"; FieldInfoArray[4].FieldChinese = "ϢС"; FieldInfoArray[4].FieldType = 10; FieldInfoArray[4].FieldLength = 0; FieldInfoArray[4].DecLength = 0; FieldInfoArray[4].CodeTable = "";FieldInfoArray[4].fUseCodeTable = false; FieldInfoArray[4].fDisplay = true; FieldInfoArray[4].DefaultValue = "";FieldInfoArray[4].FieldKind = 0; FieldInfoArray[4].IsMultiValueField = false; FieldInfoArray[4].MultiValueTable = ""; FieldInfoArray[4].fCanModify = true; FieldInfoArray[4].ForeignKeyField = "";FieldInfoArray[4].LookupKeyField = "";FieldInfoArray[4].LookupDataSet = "";FieldInfoArray[4].LookupResultField = ""; FieldInfoArray[4].RoleTable = "";FieldInfoArray[4].fAllowPick = false; FieldInfoArray[4].fForeignKey = false; 
                FieldInfoArray[5] = new UCMLCommon.FieldInfo();
                FieldInfoArray[5].FieldName = "stanza"; FieldInfoArray[5].FieldChinese = "Ϣ"; FieldInfoArray[5].FieldType = 6; FieldInfoArray[5].FieldLength = 0; FieldInfoArray[5].DecLength = 0; FieldInfoArray[5].CodeTable = "";FieldInfoArray[5].fUseCodeTable = false; FieldInfoArray[5].fDisplay = true; FieldInfoArray[5].DefaultValue = "";FieldInfoArray[5].FieldKind = 0; FieldInfoArray[5].IsMultiValueField = false; FieldInfoArray[5].MultiValueTable = ""; FieldInfoArray[5].fCanModify = true; FieldInfoArray[5].ForeignKeyField = "";FieldInfoArray[5].LookupKeyField = "";FieldInfoArray[5].LookupDataSet = "";FieldInfoArray[5].LookupResultField = ""; FieldInfoArray[5].RoleTable = "";FieldInfoArray[5].fAllowPick = false; FieldInfoArray[5].fForeignKey = false; 
                }
                fInit=true;
                localFieldInfoArray=FieldInfoArray;
            }
        if (IsUseCache) CreateDataTable();
        return localFieldInfoArray;
        }

    }
}
